Remove residual Lab & configuration DEA and DHA from the unprotected Fuel repo
[fuel.git] / build / install / install.sh
1 #!/bin/bash -e
2 ##############################################################################
3 # Copyright (c) 2015 Ericsson AB and others.
4 # stefan.k.berg@ericsson.com
5 # jonas.bjurel@ericsson.com
6 # All rights reserved. This program and the accompanying materials
7 # are made available under the terms of the Apache License, Version 2.0
8 # which accompanies this distribution, and is available at
9 # http://www.apache.org/licenses/LICENSE-2.0
10 ##############################################################################
11
12
13 my_exit() {
14     rc=$?
15
16     cd /tmp
17
18     if [ -n "$TMP_HOSTMOUNT" ]; then
19         if [ -d "$TMP_HOSTMOUNT" ]; then
20             fusermount -u $TMP_HOSTMOUNT
21             rmdir $TMP_HOSTMOUNT
22         fi
23     fi
24
25     if [ -d "$TMP_OLDISO" ]; then
26         fusermount -u $TMP_OLDISO
27         rmdir $TMP_OLDISO
28     fi
29
30     if [ -f "$CONF" ]; then
31         rm $CONF
32     fi
33
34     if [ -d "$TMP_ISOPUPPET" ]; then
35         rm -Rf $TMP_ISOPUPPET
36     fi
37 }
38
39 get_deb_name() {
40     ar p $1 control.tar.gz | tar xzO ./control | grep "^Package:.* " | sed 's/.* //'
41     if [ $PIPESTATUS -ne 0 ]; then
42         echo "Error in get_deb_name($1)"
43         exit 1
44     fi
45 }
46
47 get_deb_rev() {
48     ar p $1 control.tar.gz | tar xzO ./control | grep "^Version:.* " | sed 's/.* //'
49     if [ $PIPESTATUS -ne 0 ]; then
50         echo "Error in get_deb_rev($1)"
51         exit 1
52     fi
53 }
54
55
56 # Added logic for ".orig" files:
57 #   1. Is there an .orig file for the new file?
58 #   2. If the file is not present in base ISO -> Error!
59 #   3. If the file is changed i base ISO -> Error!  (need manual rebase)
60 #   4. If there is no .orig file, but file is present in base ISO: Error!
61 verify_orig_files() {
62     OLDDIR=$1
63     NEWDIR=$2
64
65     pushd $NEWDIR >/dev/null
66     for f in $(find * -type f -name '*.orig')
67     do
68         origfile=$NEWDIR/$f
69         oldfile=$OLDDIR/$(echo $f | sed 's/.orig$//')
70         newfile=$NEWDIR/$(echo $f | sed 's/.orig$//')
71
72         origfile=${newfile}.orig
73         # If no corresponding base file, error
74         if [ ! -f $oldfile ]; then
75             printf "\n\n\n\n"
76             echo "Error: found ${newfile} but no"
77             echo "Error: ${oldfile}"
78             echo "Error: Manual rebase is needed!"
79             printf "\n\n\n\n"
80             exit 1
81         fi
82
83         # If orig file differs from base file, error
84         if ! diff -q $origfile $oldfile > /dev/null; then
85             printf "\n\n\n\n"
86             echo "Error: $origfile differs from"
87             echo "Error: $oldfile!"
88             echo "Error: Manual rebase is needed!"
89             printf "\n\n\n\n"
90             exit 1
91         fi
92
93     done
94
95
96     # Check that there we're not overwriting oldfiles without having a ".orig" copy
97     for f in $(find * -type f ! -name '*.orig')
98     do
99         newfile=$NEWDIR/$(echo $f | sed 's/.orig$//')
100         origfile=${newfile}.orig
101         oldfile=$OLDDIR/$f
102         if [ -f $oldfile ]; then
103             if [ ! -f $origfile ]; then
104                 printf "\n\n\n\n"
105                 echo "Error: Will overwrite $oldfile, but there is no"
106                 echo "Error: $origfile!"
107                 echo "Error: You need to create the `basename $origfile`!"
108                 printf "\n\n\n\n"
109                 exit 1
110             fi
111         fi
112     done
113
114
115     popd >/dev/null
116 }
117
118 prep_make_live() {
119     DEST=$TMP_HOSTMOUNT
120     REPO=$DEST/var/www/nailgun/ubuntu/fuelweb/x86_64
121     echo "Live install"
122     ssh-copy-id root@$FUELHOST
123     sshfs root@1${FUELHOST}:/ $TMP_HOSTMOUNT
124
125     if [ -f  $REPO/dists/trusty/main/binary-amd64/Packages.backup ]; then
126         echo "Error - found backup file for Packages!"
127         exit 1
128     fi
129
130     if [ -f  $REPO/dists/trusty/main/binary-amd64/Packages.gz.backup ]; then
131         echo "Error - found backup file for Packages.gz!"
132         exit 1
133     fi
134
135     if [ -f  $REPO/dists/trusty/Release.backup ]; then
136         echo "Error - found backup file for Release!"
137         exit 1
138     fi
139
140     if [ -d  $DEST/etc/puppet.backup ]; then
141         echo "Error - found backup file for Puppet!"
142         exit 1
143     fi
144
145     cp $REPO/dists/trusty/main/binary-amd64/Packages $REPO/dists/trusty/main/binary-amd64/Packages.backup
146     cp $REPO/dists/trusty/main/binary-amd64/Packages.gz $REPO/dists/trusty/main/binary-amd64/Packages.gz.backup
147     cp $REPO/dists/trusty/Release $REPO/dists/trusty/Release.backup
148     cp -Rvp $DEST/etc/puppet $DEST/etc/puppet.backup
149 }
150
151 post_make_live() {
152     if [ -d $TOP/release/puppet/modules ]; then
153         echo "Installing into Puppet:"
154         cd $TOP/release/puppet/modules
155         if [ `ls -1 | wc -l` -gt 0 ]; then
156             for dir in *
157             do
158                 echo "   $dir"
159                 cp -Rp $dir $DEST/etc/puppet/modules
160             done
161         fi
162     fi
163 }
164
165 make_live() {
166     prep_make_live
167     copy_packages
168     post_make_live
169 }
170
171
172 prep_make_iso() {
173     DEST=$TOP/newiso
174     REPO=$DEST/ubuntu
175     echo "Making ISO..."
176     echo "Unpack of old ISO..."
177     if [ -d newiso ]; then
178         chmod -R 755 newiso
179         rm -rf newiso
180     fi
181     mkdir newiso
182     fusermount -u $TMP_OLDISO 2>/dev/null || cat /dev/null
183     fuseiso -p $ORIGISO $TMP_OLDISO
184     sleep 1
185     cd $TMP_OLDISO
186     find . | cpio -pd $TOP/newiso
187     cd ..
188     fusermount -u $TMP_OLDISO
189     rm -Rf $TMP_OLDISO
190     chmod -R 755 $TOP/newiso
191 }
192
193 make_iso_image() {
194     echo "Making ISO..."
195     cd $DEST
196     find . -name TRANS.TBL -exec rm {} \;
197     rm -rf rr_moved
198
199     mkisofs --quiet -r -V "$VOLUMEID" -publisher "$PUBLISHER" \
200         -p `git rev-parse --verify HEAD` -J -R -b isolinux/isolinux.bin \
201         -no-emul-boot \
202         -boot-load-size 4 -boot-info-table \
203         --hide-rr-moved \
204         -x "lost+found" -o $NEWISO .
205
206     isoinfo -d -i $NEWISO
207 }
208
209 # iso_copy_puppet: Create a new puppet-slave.tgz for the iso
210 iso_copy_puppet() {
211     echo "Installing into Puppet..."
212     mkdir -p $TMP_ISOPUPPET/release/puppet
213     cd $TMP_ISOPUPPET/release/puppet
214     tar xzf $DEST/puppet-slave.tgz
215     cd $TOP/release/puppet/modules
216
217     # Remove all .orig files before copying as they now have been verfied
218
219     if [ -d $TOP/release/puppet/modules ]; then
220         if [ `ls -1 | wc -l` -gt 0 ]; then
221             verify_orig_files $TMP_ISOPUPPET/release/puppet $TOP/release/puppet/modules
222             find $TOP/release/puppet/modules -type f -name '*.orig' -exec rm {} \;
223             for dir in $TOP/release/puppet/modules/*
224             do
225                 echo "   $dir"
226                 cp -Rp $dir $TMP_ISOPUPPET/release/puppet
227             done
228         fi
229     fi
230
231     cd $TMP_ISOPUPPET/release/puppet
232     tar czf $DEST/puppet-slave.tgz .
233     cd $TOP
234     rm -Rf $TMP_ISOPUPPET
235 }
236
237 # iso_modify_image: Add/patch files in the ISO root
238 iso_modify_image () {
239     # TODO: Add logic for ".orig" files (hey! make a function!), which would look
240     # something like:
241     #   1. Is there an .orig file?
242     #   2. If the file is not present in origiso -> Error exit
243     #   3. If the file is changed in origiso -> Error exit (need manual rebase)
244     #   4. Otherwise continue, but don't copy orig file (or maybe we should?)
245     # ... and corresponding reverse logic:
246     #   1. If there is no .orig file, but file is present in origiso -> Error exit
247     echo "Modify ISO files (wild copy)..."
248
249     verify_orig_files $DEST $TOP/release/isoroot
250     # Remove all .orig files before copying as they now have been verfied
251     find $TOP/release/isoroot -type f -name '*.orig' -exec rm {} \;
252
253     cd $TOP/release/isoroot
254     cp -Rvp . $DEST
255
256     # Add all Git info files
257     sort $TOP/gitinfo*.txt > $DEST/gitinfo.txt
258     cp $DEST/gitinfo.txt $REPORTFILE
259 }
260
261 make_iso() {
262     prep_make_iso
263     copy_packages
264     #iso_copy_puppet
265     iso_modify_image
266     make_iso_image
267 }
268
269 copy_packages() {
270     echo "Copying Debian packages..."
271     cd $TOP/release/packages/ubuntu/pool/debian-installer
272
273     for udeb in `ls -1 | grep '\.udeb$'`
274     do
275         echo "   $udeb"
276         cp $udeb $REPO/pool/debian-installer
277         echo "Did not expect a package here, not supported"
278         exit 1
279     done
280
281     cd $TOP/release/packages/ubuntu/pool/main
282     for deb in `ls -1 | grep '\.deb$'`
283     do
284         echo "   $deb"
285         cp $deb $REPO/pool/main
286         echo "Did not expect a package here, not supported"
287         exit 1
288     done
289
290     echo "Running Fuel package patch file"
291     pushd $REPO/pool/main > /dev/null
292
293     for line in `cat $TOP/apply_patches | grep -v "^#" | grep -v "^$"`; do
294         echo "Line is $line"
295         echo "Did not expect a line here, not supported"
296         exit 1
297         ref=`echo $line | cut -d '>' -f 1`
298         origpkg=`echo $line| cut -d '>' -f 2`
299         url=`echo $line | cut -d '>' -f 3`
300
301         if [ -z "$origpkg" ]; then
302             echo "Error: No origpkg for patching"
303             exit 1
304         fi
305
306         if [ -z "$url" ]; then
307             echo "Error: No url for patching"
308             exit 1
309         fi
310
311         if [ -z "$ref" ]; then
312             echo "Error: No reference text for patching"
313             exit 1
314         fi
315
316         echo "CM: Patching Fuel package for $ref" | tee -a $REPORTFILE
317         echo "CM: Replacing package $origpkg with $url" | tee -a $REPORTFILE
318         oldrev=`get_deb_rev $origpkg`
319         rm $origpkg
320         wget --quiet $url
321         topkg=`basename $url`
322         echo "CM: MD5 of new package:" | tee -a $REPORTFILE
323         md5sum $topkg | tee -a $REPORTFILE
324
325         patchname=`get_deb_name $topkg`
326         patchrev=`get_deb_rev $topkg`
327         echo "Correcting dependencies towards $patchname rev $patchrev - old rev $oldrev" | tee -a $REPORTFILE
328         $TOP/patch-packages/tools/correct_deps $patchname $oldrev $patchrev | tee -a $REPORTFILE
329         if [ $PIPESTATUS -ne 0 ]; then
330             exit 1
331         fi
332     done
333
334     printf "Done running Fuel patch file\n\n"
335     echo "Running add packages file"
336     for line in `cat $TOP/add_opnfv_packages | grep -v "^#" | grep -v "^$"`; do
337         echo "Line is $line"
338         echo "Did not expect a line here, not supported"
339         exit 1
340         ref=`echo $line | cut -d '>' -f 1`
341         origpkg=`echo $line| cut -d '>' -f 2`
342         url=`echo $line | cut -d '>' -f 3`
343
344         if [ -z "$origpkg" ]; then
345             echo "Error: No origpkg for patching"
346             exit 1
347         fi
348
349         if [ -z "$url" ]; then
350             echo "Error: No url for patching"
351             exit 1
352         fi
353
354         if [ -z "$ref" ]; then
355             echo "Error: No reference text for patching"
356             exit 1
357         fi
358
359         if [ "$origpkg" != "NONE" ]; then
360             echo "CM: Patching added package for $ref" | tee -a $REPORTFILE
361             echo "CM: Replacing package $origpkg with $url" | tee -a $REPORTFILE
362             oldrev=`get_deb_rev $origpkg`
363             rm $origpkg
364         else
365             echo "CM: Adding previoulsy uninstalled package for $ref" tee -a $REPORTFILE
366         fi
367         wget --quiet $url
368         topkg=`basename $url`
369         echo "CM: MD5 of new package:" | tee -a $REPORTFILE
370         md5sum $topkg | tee -a $REPORTFILE
371         if [ "$origpkg" != "NONE" ]; then
372             patchname=`get_deb_name $topkg`
373             patchrev=`get_deb_rev $topkg`
374             echo "Correcting dependencies towards $patchname rev $patchrev - old rev $oldrev" | tee -a $REPORTFILE
375             $TOP/patch-packages/tools/correct_deps $patchname $oldrev $patchrev | tee -a $REPORTFILE
376             if [ $PIPESTATUS -ne 0 ]; then
377                 exit 1
378             fi
379         fi
380     done
381     printf "Done running add packages file\n\n"
382
383     popd > /dev/null
384
385     if [ -f $TOP/patch-packages/release/patch-replacements ]; then
386         echo "Applying package patches" | tee -a $REPORTFILE
387         pushd $REPO/pool/main > /dev/null
388         printf "\n\n" | tee -a  $REPORTFILE
389         for line in `cat $TOP/patch-packages/release/patch-replacements`
390         do
391             echo "Did not expect a line here, not supported"
392             exit 1
393             frompkg=`echo $line | cut -d ">" -f 1`
394             topkg=`echo $line | cut -d ">" -f 2`
395             echo "CM: Applying patch to $frompkg" | tee -a $REPORTFILE
396             echo "CM: New package rev after patch: $topkg" | tee -a $REPORTFILE
397
398             if [ ! -f $frompkg ]; then
399                 echo "Error: Can't find $frompkg in repo"
400                 exit 1
401             else
402                 oldrev=`get_deb_rev $frompkg`
403                 echo "Removing $frompkg from repo"
404                 rm $frompkg
405             fi
406
407             if [ ! -f $TOP/patch-packages/release/packages/$topkg ]; then
408                 echo "Error: Can't find $topkg in patch release"
409                 exit 1
410             else
411                 echo "Adding $topkg to repo"
412                 cp $TOP/patch-packages/release/packages/$topkg .
413             fi
414
415             patchname=`get_deb_name $topkg`
416             patchrev=`get_deb_rev $topkg`
417             echo "Correcting dependencies towards $patchname rev $patchrev - old rev $oldrev" | tee -a $REPORTFILE
418             $TOP/patch-packages/tools/correct_deps $patchname $oldrev $patchrev | tee -a $REPORTFILE
419             if [ $PIPESTATUS -ne 0 ]; then
420                 exit 1
421             fi
422         done
423         popd > /dev/null
424     fi
425
426     echo "Generating metadata..."
427     pushd $REPO > /dev/null
428
429     # The below methods are from 15B
430     APT_REL_CONF="$TOP/install/apt-ftparchive-release.conf"
431     APT_DEB_CONF="$TOP/install/apt-ftparchive-deb.conf"
432     APT_UDEB_CONF="$TOP/install/apt-ftparchive-udeb.conf"
433
434     echo Not running echo apt-ftparchive -c "${APT_REL_CONF}" generate "${APT_DEB_CONF}"
435     echo Not running apt-ftparchive -c "${APT_REL_CONF}" generate "${APT_DEB_CONF}"
436     echo Not running apt-ftparchive generate "${APT_UDEB_CONF}"
437     echo Not running apt-ftparchive generate "${APT_UDEB_CONF}"
438
439     # Fuel also needs this index file
440     # cat dists/trusty/main/binary-amd64/Packages | \
441     #    awk '/^Package:/{pkg=$2}
442     # /^Version:/{print pkg ": \"" $2 "\""}' > ubuntu-versions.yaml
443     # cp ubuntu-versions.yaml $DEST
444
445     # apt-ftparchive -c "${APT_REL_CONF}" release dists/trusty/ > dists/trusty/Release
446     # gzip -9cf dists/trusty/Release > dists/trusty/Release.gz
447
448     popd > /dev/null
449
450 }
451
452
453 #############################################################################
454
455 trap my_exit EXIT
456
457 CONF=`mktemp /tmp/XXXXXXX`
458 MODE=$1
459 TOP=`pwd`
460
461 if [ $MODE = "iso" ]; then
462     PUBLISHER="OPNFV"
463     TMP_OLDISO=`mktemp -d /tmp/XXXXXXX`
464     TMP_ISOPUPPET=`mktemp -d /tmp/XXXXXXX`
465     ORIGISO=$2
466     NEWISO=$3
467     VOLUMEID="$4_$5"
468     REPORTFILE="${NEWISO}.txt"
469     echo "Opening reportfile at $REPORTFILE"
470     touch $REPORTFILE
471     if [ ! -f $ORIGISO ]; then
472         echo "Can't find original iso at $ORIGISO"
473         rm $CONF
474         exit 1
475     fi
476
477     make_iso
478 else
479     echo "Unknown mode: $MODE"
480     exit 1
481 fi